<!DOCTYPE html>
<html lang="en">

<head>
   <meta charset="UTF-8">
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   <meta http-equiv="X-UA-Compatible" content="ie=edge">
   <title>Document</title>
</head>

<body>
   

   <script>
      class MiBoton extends HTMLElement {
         constructor() {
            super();
            this.addEventListener('click', function (e) {
               alert('hola');
            });
         }
      }

      customElements.define('mi-boton', MiBoton);

      customElements.define('mi-boton2', class extends HTMLElement {
         constructor() {
            super();
            this.addEventListener('click', function (e) {
               alert('hola soy boton 2');
            });
         }
      });

   </script>
   
<p>Custom</p>
<mi-boton>Soy un mi boton</mi-boton>
<mi-Boton2>Soy un mi boton</mi-Boton2>

</body>

</html>